diff --git a/hw/xquartz/X11Controller.m b/hw/xquartz/X11Controller.m
index e21aed0d3..c75493c42 100644
--- a/hw/xquartz/X11Controller.m
+++ b/hw/xquartz/X11Controller.m
@@ -29,14 +29,16 @@
  */
 
 #include "sanitizedCarbon.h"
+#include <AvailabilityMacros.h>
 
 #ifdef HAVE_DIX_CONFIG_H
 #include <dix-config.h>
 #endif
 
+#include "quartzCommon.h"
+
 #import "X11Controller.h"
 #import "X11Application.h"
-#import "NSUserDefaults+XQuartzDefaults.h"
 
 #include "opaque.h"
 #include "darwin.h"
@@ -57,37 +59,26 @@
 extern aslclient aslc;
 extern char *bundle_id_prefix;
 
-@interface X11Controller ()
-#ifdef XQUARTZ_SPARKLE
-@property (nonatomic, readwrite, strong) NSMenuItem *check_for_updates_item; // Programatically enabled
-#endif
-
-@property (nonatomic, readwrite, strong) NSArray <NSArray <NSString *> *> *apps;
-@property (nonatomic, readwrite, strong) NSMutableArray <NSMutableArray <NSString *> *> *table_apps;
-@property (nonatomic, readwrite, assign) NSInteger windows_menu_nitems;
-@property (nonatomic, readwrite, assign) int checked_window_item;
-@property (nonatomic, readwrite, assign) x_list *pending_apps;
-@property (nonatomic, readwrite, assign) OSX_BOOL finished_launching;
-@end
-
 @implementation X11Controller
 
 - (void) awakeFromNib
 {
     X11Application *xapp = NSApp;
+    NSArray *array;
 
     /* Point X11Application at ourself. */
-    xapp.controller = self;
-
-    NSUserDefaults * const defaults = NSUserDefaults.xquartzDefaults;
-    NSArray *appsMenu = [defaults arrayForKey:XQuartzPrefKeyAppsMenu];
+    [xapp set_controller:self];
 
-    if (appsMenu) {
-        int count = appsMenu.count;
+    array = [xapp prefs_get_array:@PREFS_APPSMENU];
+    if (array != nil) {
+        int count;
 
         /* convert from [TITLE1 COMMAND1 TITLE2 COMMAND2 ...]
            to [[TITLE1 COMMAND1] [TITLE2 COMMAND2] ...] format. */
-        if (count > 0 && ![appsMenu[0] isKindOfClass:NSArray.class]) {
+
+        count = [array count];
+        if (count > 0
+            && ![[array objectAtIndex:0] isKindOfClass:[NSArray class]]) {
             int i;
             NSMutableArray *copy, *sub;
 
@@ -95,24 +86,32 @@ - (void) awakeFromNib
 
             for (i = 0; i < count / 2; i++) {
                 sub = [[NSMutableArray alloc] initWithCapacity:3];
-                [sub addObject:appsMenu[i * 2]];
-                [sub addObject:appsMenu[i * 2 + 1]];
+                [sub addObject:[array objectAtIndex:i * 2]];
+                [sub addObject:[array objectAtIndex:i * 2 + 1]];
                 [sub addObject:@""];
                 [copy addObject:sub];
                 [sub release];
             }
 
-            appsMenu = copy;
-            [defaults setObject:appsMenu forKey:XQuartzPrefKeyAppsMenu];
+            array = copy;
         }
 
-        [self set_apps_menu:appsMenu];
+        [self set_apps_menu:array];
+    }
+
+    [[NSNotificationCenter defaultCenter]
+     addObserver: self
+        selector: @selector(apps_table_done:)
+            name: NSWindowWillCloseNotification
+          object: [apps_table window]];
+
+    // Setup data about our Windows menu
+    if (window_separator) {
+        [[window_separator menu] removeItem:window_separator];
+        window_separator = nil;
     }
 
-    [NSNotificationCenter.defaultCenter addObserver:self
-                                           selector:@selector(apps_table_done:)
-                                               name:NSWindowWillCloseNotification
-                                             object:self.apps_table.window];
+    windows_menu_start = [[X11App windowsMenu] numberOfItems];
 }
 
 - (void) item_selected:sender
@@ -123,16 +122,80 @@ - (void) item_selected:sender
                        AppleWMWindowMenuItem, [sender tag]);
 }
 
+- (void) remove_window_menu
+{
+    NSMenu *menu;
+    int count, i;
+
+    /* Work backwards so we don't mess up the indices */
+    menu = [X11App windowsMenu];
+    count = [menu numberOfItems];
+    for (i = count - 1; i >= windows_menu_start; i--)
+        [menu removeItemAtIndex:i];
+
+    count = [dock_menu indexOfItem:dock_window_separator];
+    for (i = 0; i < count; i++)
+        [dock_menu removeItemAtIndex:0];
+}
+
+- (void) install_window_menu:(NSArray *)list
+{
+    NSMenu *menu;
+    NSMenuItem *item;
+    int first, count, i;
+
+    menu = [X11App windowsMenu];
+    first = windows_menu_start + 1;
+    count = [list count];
+
+    // Push a Separator
+    if (count) {
+        [menu addItem:[NSMenuItem separatorItem]];
+    }
+
+    for (i = 0; i < count; i++) {
+        NSString *name, *shortcut;
+
+        name = [[list objectAtIndex:i] objectAtIndex:0];
+        shortcut = [[list objectAtIndex:i] objectAtIndex:1];
+
+        if (windowItemModMask == 0 || windowItemModMask == -1)
+            shortcut = @"";
+
+        item =
+            (NSMenuItem *)[menu addItemWithTitle:name action:
+                           @selector
+                           (item_selected:) keyEquivalent:shortcut];
+        [item setKeyEquivalentModifierMask:(NSUInteger)windowItemModMask];
+        [item setTarget:self];
+        [item setTag:i];
+        [item setEnabled:YES];
+
+        item = (NSMenuItem *)[dock_menu  insertItemWithTitle:name
+                                                      action:@selector
+                              (item_selected:) keyEquivalent:shortcut
+                                                     atIndex:i];
+        [item setKeyEquivalentModifierMask:(NSUInteger)windowItemModMask];
+        [item setTarget:self];
+        [item setTag:i];
+        [item setEnabled:YES];
+    }
+
+    if (checked_window_item >= 0 && checked_window_item < count) {
+        item = (NSMenuItem *)[menu itemAtIndex:first + checked_window_item];
+        [item setState:NSOnState];
+        item = (NSMenuItem *)[dock_menu itemAtIndex:checked_window_item];
+        [item setState:NSOnState];
+    }
+}
+
 - (void) remove_apps_menu
 {
     NSMenu *menu;
     NSMenuItem *item;
     int i;
 
-    NSMenuItem * const apps_separator = self.apps_separator;
-    NSMenu * const dock_apps_menu = self.dock_apps_menu;
-
-    if (self.apps == nil || apps_separator == nil) return;
+    if (apps == nil || apps_separator == nil) return;
 
     menu = [apps_separator menu];
 
@@ -152,13 +215,14 @@ - (void) remove_apps_menu
         }
     }
 
-    self.apps = nil;
+    [apps release];
+    apps = nil;
 }
 
-- (void) prepend_apps_item:(NSArray <NSArray <NSString *> *> *)list index:(int)i menu:(NSMenu *)menu
+- (void) prepend_apps_item:(NSArray *)list index:(int)i menu:(NSMenu *)menu
 {
     NSString *title, *shortcut = @"";
-    NSArray <NSString *> *group;
+    NSArray *group;
     NSMenuItem *item;
 
     group = [list objectAtIndex:i];
@@ -182,16 +246,13 @@ - (void) prepend_apps_item:(NSArray <NSArray <NSString *> *> *)list index:(int)i
     [item setTag:i + 1];                  /* can't be zero, so add one */
 }
 
-- (void) install_apps_menu:(NSArray <NSArray <NSString *> *> *)list
+- (void) install_apps_menu:(NSArray *)list
 {
     NSMenu *menu;
     int i, count;
 
     count = [list count];
 
-    NSMenuItem * const apps_separator = self.apps_separator;
-    NSMenu * const dock_apps_menu = self.dock_apps_menu;
-
     if (count == 0 || apps_separator == nil) return;
 
     menu = [apps_separator menu];
@@ -203,89 +264,28 @@ - (void) install_apps_menu:(NSArray <NSArray <NSString *> *> *)list
             [self prepend_apps_item:list index:i menu:dock_apps_menu];
     }
 
-    self.apps = list;
+    apps = [list retain];
 }
 
-- (void) set_window_menu:(NSArray <NSArray <NSString *> *> *)list
+- (void) set_window_menu:(NSArray *)list
 {
-    NSMenu * const menu = X11App.windowsMenu;
-    NSMenu * const dock_menu = self.dock_menu;
-
-    /* First, remove the existing items from the Window Menu */
-    NSInteger itemsToRemove = self.windows_menu_nitems;
-    if (itemsToRemove > 0) {
-        NSInteger indexForRemoval = menu.numberOfItems - itemsToRemove - 1; /* we also want to remove the separator */
-
-        for (NSInteger i = 0 ; i < itemsToRemove + 1 ; i++) {
-            [menu removeItemAtIndex:indexForRemoval];
-        }
-
-        for (NSInteger i = 0 ; i < itemsToRemove; i++) {
-            [dock_menu removeItemAtIndex:0];
-        }
-    }
-
-    NSInteger const itemsToAdd = list.count;
-    self.windows_menu_nitems = itemsToAdd;
+    [self remove_window_menu];
+    [self install_window_menu:list];
 
-    if (itemsToAdd > 0) {
-        NSMenuItem *item;
-
-        // Push a Separator
-        [menu addItem:[NSMenuItem separatorItem]];
-
-        for (NSInteger i = 0; i < itemsToAdd; i++) {
-            NSString *name, *shortcut;
-
-            name = list[i][0];
-            shortcut = list[i][1];
-
-            if (windowItemModMask == 0 || windowItemModMask == -1)
-                shortcut = @"";
-
-            item = (NSMenuItem *)[menu addItemWithTitle:name
-                                                 action:@selector(item_selected:)
-                                          keyEquivalent:shortcut];
-            [item setKeyEquivalentModifierMask:(NSUInteger)windowItemModMask];
-            [item setTarget:self];
-            [item setTag:i];
-            [item setEnabled:YES];
-
-            item = (NSMenuItem *)[dock_menu  insertItemWithTitle:name
-                                                          action:@selector(item_selected:)
-                                                   keyEquivalent:shortcut
-                                                         atIndex:i];
-            [item setKeyEquivalentModifierMask:(NSUInteger)windowItemModMask];
-            [item setTarget:self];
-            [item setTag:i];
-            [item setEnabled:YES];
-        }
-
-        int const checked_window_item = self.checked_window_item;
-        if (checked_window_item >= 0 && checked_window_item < itemsToAdd) {
-            NSInteger first = menu.numberOfItems - itemsToAdd;
-            item = (NSMenuItem *)[menu itemAtIndex:first + checked_window_item];
-            [item setState:NSOnState];
-
-            item = (NSMenuItem *)[dock_menu itemAtIndex:checked_window_item];
-            [item setState:NSOnState];
-        }
-    }
-
-    DarwinSendDDXEvent(kXquartzControllerNotify, 1, AppleWMWindowMenuNotify);
+    DarwinSendDDXEvent(kXquartzControllerNotify, 1,
+                       AppleWMWindowMenuNotify);
 }
 
 - (void) set_window_menu_check:(NSNumber *)nn
 {
-    NSMenu * const menu = X11App.windowsMenu;
-    NSMenu * const dock_menu = self.dock_menu;
+    NSMenu *menu;
     NSMenuItem *item;
-    int n = nn.intValue;
-
-    NSInteger const count = self.windows_menu_nitems;
-    NSInteger const first = menu.numberOfItems - count;
+    int first, count;
+    int n = [nn intValue];
 
-    int const checked_window_item = self.checked_window_item;
+    menu = [X11App windowsMenu];
+    first = windows_menu_start + 1;
+    count = [menu numberOfItems] - first;
 
     if (checked_window_item >= 0 && checked_window_item < count) {
         item = (NSMenuItem *)[menu itemAtIndex:first + checked_window_item];
@@ -299,10 +299,10 @@ - (void) set_window_menu_check:(NSNumber *)nn
         item = (NSMenuItem *)[dock_menu itemAtIndex:n];
         [item setState:NSOnState];
     }
-    self.checked_window_item = n;
+    checked_window_item = n;
 }
 
-- (void) set_apps_menu:(NSArray <NSArray <NSString *> *> *)list
+- (void) set_apps_menu:(NSArray *)list
 {
     [self remove_apps_menu];
     [self install_apps_menu:list];
@@ -311,29 +311,31 @@ - (void) set_apps_menu:(NSArray <NSArray <NSString *> *> *)list
 #ifdef XQUARTZ_SPARKLE
 - (void) setup_sparkle
 {
-    if (self.check_for_updates_item)
+    if (check_for_updates_item)
         return;  // already did it...
 
-    NSMenu *menu = [self.x11_about_item menu];
+    NSMenu *menu = [x11_about_item menu];
 
-    NSMenuItem * const check_for_updates_item =
-        [menu insertItemWithTitle:NSLocalizedString(@"Check for X11 Updates...", @"Check for X11 Updates...")
-                           action:@selector(checkForUpdates:)
-                    keyEquivalent:@""
-                          atIndex:1];
+    check_for_updates_item =
+        [menu insertItemWithTitle:NSLocalizedString(
+             @"Check for X11 Updates...",
+             @"Check for X11 Updates...")
+         action:@selector (
+             checkForUpdates:)
+         keyEquivalent:@""
+         atIndex:1];
     [check_for_updates_item setTarget:[SUUpdater sharedUpdater]];
     [check_for_updates_item setEnabled:YES];
 
-    self.check_for_updates_item = check_for_updates_item;
-
     // Set X11Controller as the delegate for the updater.
     [[SUUpdater sharedUpdater] setDelegate:self];
 }
 
 // Sent immediately before installing the specified update.
-- (void)updater:(SUUpdater *)updater willInstallUpdate:(SUAppcastItem *)update
+- (void)updater:(SUUpdater *)updater willInstallUpdate:(SUAppcastItem *)
+   update
 {
-    //self.can_quit = YES;
+    //[self set_can_quit:YES];
 }
 
 #endif
@@ -345,15 +347,14 @@ - (void) launch_client:(NSString *)filename
     const char *newargv[4];
     char buf[128];
     char *s;
+#if MAC_OS_X_VERSION_MAX_ALLOWED >= 1080
     int stdout_pipe[2];
     int stderr_pipe[2];
+#endif
 
-    NSUserDefaults * const defaults = NSUserDefaults.xquartzDefaults;
-    NSString * const shell = [defaults stringForKey:XQuartzPrefKeyLoginShell];
-
-    newargv[0] = shell.fileSystemRepresentation;
+    newargv[0] = [X11App prefs_get_string:@PREFS_LOGIN_SHELL default:"/bin/sh"];
     newargv[1] = "-c";
-    newargv[2] = filename.fileSystemRepresentation;
+    newargv[2] = [filename UTF8String];
     newargv[3] = NULL;
 
     s = getenv("DISPLAY");
@@ -362,6 +363,7 @@ - (void) launch_client:(NSString *)filename
         setenv("DISPLAY", buf, TRUE);
     }
 
+#if MAC_OS_X_VERSION_MAX_ALLOWED >= 1080
     if (&asl_log_descriptor) {
         char *asl_sender;
         aslmsg amsg = asl_new(ASL_TYPE_MSG);
@@ -393,6 +395,7 @@ - (void) launch_client:(NSString *)filename
 
         asl_free(amsg);
     }
+#endif
 
     /* Do the fork-twice trick to avoid having to reap zombies */
     child1 = fork();
@@ -410,11 +413,13 @@ - (void) launch_client:(NSString *)filename
             _exit(1);
 
         case 0:                                     /* child2 */
+#if MAC_OS_X_VERSION_MAX_ALLOWED >= 1080
             if (&asl_log_descriptor) {
                 /* Replace our stdout/stderr */
                 dup2(stdout_pipe[1], STDOUT_FILENO);
                 dup2(stderr_pipe[1], STDERR_FILENO);
             }
+#endif
 
             /* close all open files except for standard streams */
             max_files = sysconf(_SC_OPEN_MAX);
@@ -437,18 +442,19 @@ - (void) launch_client:(NSString *)filename
         waitpid(child1, &status, 0);
     }
 
+#if MAC_OS_X_VERSION_MAX_ALLOWED >= 1080
     if (&asl_log_descriptor) {
         /* Close the write ends of the pipe */
         close(stdout_pipe[1]);
         close(stderr_pipe[1]);
     }
+#endif
 }
 
 - (void) app_selected:sender
 {
     int tag;
     NSString *item;
-    NSArray <NSArray <NSString *> *> * const apps = self.apps;
 
     tag = [sender tag] - 1;
     if (apps == nil || tag < 0 || tag >= [apps count])
@@ -462,18 +468,14 @@ - (void) app_selected:sender
 - (IBAction) apps_table_show:sender
 {
     NSArray *columns;
-    NSMutableArray <NSMutableArray <NSString *> *> * const oldapps = self.table_apps;
-    NSTableView * const apps_table = self.apps_table;
+    NSMutableArray *oldapps = nil;
 
-    NSMutableArray <NSMutableArray <NSString *> *> * const table_apps = [[NSMutableArray alloc] initWithCapacity:1];
-    self.table_apps = table_apps;
+    if (table_apps != nil)
+        oldapps = table_apps;
 
-    NSArray <NSArray <NSString *> *> * const apps = self.apps;
-    if (apps != nil) {
-        for (NSArray <NSString *> * row in apps) {
-            [table_apps addObject:row.mutableCopy];
-        }
-    }
+    table_apps = [[NSMutableArray alloc] initWithCapacity:1];
+    if (apps != nil)
+        [table_apps addObjectsFromArray:apps];
 
     columns = [apps_table tableColumns];
     [[columns objectAtIndex:0] setIdentifier:@"0"];
@@ -492,26 +494,23 @@ - (IBAction) apps_table_show:sender
 
 - (IBAction) apps_table_done:sender
 {
-    NSMutableArray <NSMutableArray <NSString *> *> * const table_apps = self.table_apps;
-    NSTableView * const apps_table = self.apps_table;
     [apps_table deselectAll:sender];    /* flush edits? */
 
     [self remove_apps_menu];
     [self install_apps_menu:table_apps];
 
-    NSUserDefaults * const defaults = NSUserDefaults.xquartzDefaults;
-    [defaults setObject:table_apps forKey:XQuartzPrefKeyAppsMenu];
+    [NSApp prefs_set_array:@PREFS_APPSMENU value:table_apps];
+    [NSApp prefs_synchronize];
 
     [[apps_table window] orderOut:sender];
 
-    self.table_apps = nil;
+    [table_apps release];
+    table_apps = nil;
 }
 
 - (IBAction) apps_table_new:sender
 {
     NSMutableArray *item;
-    NSMutableArray <NSMutableArray <NSString *> *> * const table_apps = self.table_apps;
-    NSTableView * const apps_table = self.apps_table;
 
     int row = [apps_table selectedRow], i;
 
@@ -539,10 +538,8 @@ - (IBAction) apps_table_new:sender
 
 - (IBAction) apps_table_duplicate:sender
 {
-    NSMutableArray <NSMutableArray <NSString *> *> * const table_apps = self.table_apps;
-    NSTableView * const apps_table = self.apps_table;
     int row = [apps_table selectedRow], i;
-    NSMutableArray <NSString *> *item;
+    NSObject *item;
 
     if (row < 0) {
         [self apps_table_new:sender];
@@ -565,8 +562,6 @@ - (IBAction) apps_table_duplicate:sender
 
 - (IBAction) apps_table_delete:sender
 {
-    NSMutableArray <NSMutableArray <NSString *> *> * const table_apps = self.table_apps;
-    NSTableView * const apps_table = self.apps_table;
     int row = [apps_table selectedRow];
 
     if (row >= 0) {
@@ -589,7 +584,6 @@ - (IBAction) apps_table_delete:sender
 
 - (NSInteger) numberOfRowsInTableView:(NSTableView *)tableView
 {
-    NSMutableArray <NSMutableArray <NSString *> *> * const table_apps = self.table_apps;
     if (table_apps == nil) return 0;
 
     return [table_apps count];
@@ -598,7 +592,6 @@ - (NSInteger) numberOfRowsInTableView:(NSTableView *)tableView
 - (id)             tableView:(NSTableView *)tableView
    objectValueForTableColumn:(NSTableColumn *)tableColumn row:(NSInteger)row
 {
-    NSMutableArray <NSMutableArray <NSString *> *> * const table_apps = self.table_apps;
     NSArray *item;
     int col;
 
@@ -616,8 +609,7 @@ - (id)             tableView:(NSTableView *)tableView
 - (void) tableView:(NSTableView *)tableView setObjectValue:(id)object
     forTableColumn:(NSTableColumn *)tableColumn row:(NSInteger)row
 {
-    NSMutableArray <NSMutableArray <NSString *> *> * const table_apps = self.table_apps;
-    NSMutableArray <NSString *> *item;
+    NSMutableArray *item;
     int col;
 
     if (table_apps == nil) return;
@@ -677,15 +669,16 @@ - (IBAction) previous_window:sender
 
 - (IBAction) enable_fullscreen_changed:sender
 {
-    XQuartzRootlessDefault = !self.enable_fullscreen.state;
+    XQuartzRootlessDefault = ![enable_fullscreen intValue];
 
-    [self.enable_fullscreen_menu setEnabled:!XQuartzRootlessDefault];
-    [self.enable_fullscreen_menu_text setTextColor:XQuartzRootlessDefault ? NSColor.disabledControlTextColor : NSColor.controlTextColor];
+    [enable_fullscreen_menu setEnabled:!XQuartzRootlessDefault];
+    [enable_fullscreen_menu_text setTextColor:XQuartzRootlessDefault ?[
+         NSColor disabledControlTextColor] : [NSColor controlTextColor]];
 
     DarwinSendDDXEvent(kXquartzSetRootless, 1, XQuartzRootlessDefault);
 
-    NSUserDefaults * const defaults = NSUserDefaults.xquartzDefaults;
-    [defaults setBool:XQuartzRootlessDefault forKey:XQuartzPrefKeyRootless];
+    [NSApp prefs_set_boolean:@PREFS_ROOTLESS value:XQuartzRootlessDefault];
+    [NSApp prefs_synchronize];
 }
 
 - (IBAction) toggle_fullscreen:sender
